100 REMark PigeonSort number sorting routine
110 WINDOW 256,202,256,23 :WINDOW#2;256,202,0,23
120 WINDOW#0;512,32,0,224
130 FOR ChanNum=0 TO 2
140   INK#ChanNum;7
150   PAPER#ChanNum;0
160   BORDER#ChanNum;1,2
170   CLS#ChanNum
180 END FOR ChanNum
190 MODE 4
200 REPeat Program
210   INPUT#0;"Number of items to sort;";NMax
220   IF NMax<2 THEN EXIT Program
230   DIM DataItems(NMax) : REMark array holding numbers to be sorted
240   DIM DataIndex(NMax) : REMark index array
250   PRINT 'Setting up...'
260   SetupData
270   PRINT 'Sorting ';NMax;' items...'
280   StartTime = DATE
290   PigeonSort DataItems,DataIndex,NMax
300   TotalTime = DATE - StartTime
310   TotalTime$ = DATE$(TotalTime):PRINT 'Sort time approx: ';TotalTime$(13 TO)
320   PRINT "Checking..."
330   validateSort
340 END REPeat Program
350 :
10000 DEFine PROCedure PigeonSort(P,IP,N)
10010   LOCal NoOfSlot(NMax),NoInSlot(NMax),NPig(NMax+1):REMark INTEGERS
10020   LOCal IPP(NMax),NoInPig(N
ax):REMark INTEGES
10030   REMark IPP(NMax) - Working index to P; only N elements used
10040   REMark the following are LOCal INTEGERS
10050   REMark NoInPig(NMax) - Number of elements in pigeonhole
10060   REMark NoOfSlot(NMax) - Number of slot for element during sort
10070   REMark NoInSlot(NMax) - Number of elements in slot during sort
10080   REMark NPig(NMax + 1) - Number of pigeonhole for sort-slot
10090   REMark PMin - Minimum element of P in current sub-sort
10100   REMark the following are LOCal REALS
10110   REMark PMax - Maximum element of P in current sub-sort
10120   REMark Slot - Reciprocal of slot-size used in sub-sort
10130   REMark the following are LOCal INTEGERS
10140   REMark I - Index used to move through IP(I)
10150   REMark IStart - First value of I in current sub-sort
10160   REMark IStart1 - Working index = IStart + 1
10170   REMark IStart2 - Working index = IStart + 2
10180   REMark IStart3 - Working index = IStart + 3
10190   REMark IEnd - Last value of I in current sub-sort
10200   REMark IPTemp - Temporary store to swap elements of IP
10210   REMark IP0 - Temporary store holding IP(IStart + 0)
10220   REMark IP1 - Temporary store holding IP(IStart + 1)
10230   REMark IP2 - Temporary store holding IP(IStart + 2)
10240   REMark ip3 - Temporary store holding IP(IStart + 3)
10250   REMark J - Index used to move through slots
10260   IStart = 1
10270   NoInPig(1) = N
10280   REPeat Loop1
10290     IF IStart >= N THEN EXIT Loop1
10300     REPeat Loop2
10310       IF NoInPig(IStart) <= 1 THEN EXIT Loop2
10320       IF NoInPig(IStart) > 2 THEN
10330         IF NoInPig(IStart) > 3 THEN
10340           IF NoInPig(IStart) > 4 THEN
10350             IEnd = IStart + NoInPig(IStart) - 1
10360             IStart1 = IStart + 1
10370             PMax = P(IP(IStart))
10380             PMin = PMax
10390             FOR I = IStart1 TO IEnd
10400               IF P(IP(I)) > PMax THEN
10410                 PMax = P(IP(I))
10420               ELSE
10430                 IF P(IP(I)) < PMin THEN PMin = P(IP(I))
10440               END IF
10450             END FOR I
10460             IF PMax = PMin THEN EXIT Loop2:REMark All values equal; skip sub-sort
10470             Slot = NoInPig(IStart) / (PMax - PMin)
10480             FOR I = IStart TO IEnd
10490               NoOfSlot(I) = INT((P(IP(I)) - PMin) * Slot)
10500               NoInSlot(NoOfSlot(I)) = NoInSlot(NoOfSlot(I)) + 1
10510             END FOR I
10520             NPig(0) = IStart
10530             FOR J = 0 TO NoInPig(IStart)
10540               NPig(J + 1) = NPig(J) + NoInSlot(J)
10550               IF NoInSlot(J) <> 0 THEN NoInPig(NPig(J)) = NoInSlot(J)
10560               NoInSlot(J) = 0
10570             END FOR J
10580             FOR I = IStart TO IEnd
10590               IPP(NPig(NoOfSlot(I))) = IP(I)
10600               NPig(NoOfSlot(I)) = NPig(NoOfSlot(I)) +1
10610             END FOR I
10620             FOR I = IStart TO IEnd
10630               IP(I) = IPP(I)
10640             END FOR I
10650           ELSE
10660 REMark Do opimal sorts explicitly for small numbers (2-4) in pigeonhole
10670             IStart1 = IStart + 1:REMark Sort 4 with 5 swaps
10680             IStart2 = IStart + 2
10690             IStart3 = IStart + 3
10700             IF P(IP(IStart)) > P(IP(IStart2)) THEN
10710               IPTemp = IP(IStart2)
10720               IP(IStart2) = IP(IStart)
10730               IP(IStart) = IPTemp
10740             END IF
10750             IF P(IP(IStart1)) > P(IP(IStart3)) THEN
10760               IPTemp = IP(IStart3)
10770               IP(IStart3) = IP(IStart1)
10780               IP(IStart1) = IPTemp
10790             END IF
10800             IF P(IP(IStart)) > P(IP(IStart1)) THEN
10810               IPTemp = IP(IStart1)
10820               IP(IStart1) = IP(IStart)
10830               IP(IStart) = IPTemp
10840             END IF
10850             IF P(IP(IStart2)) > P(IP(IStart3)) THEN
10860               IPTemp = IP(IStart3)
10870               IP(IStart3) = IP(IStart2)
10880               IP(IStart2) = IPTemp
10890             END IF
10900             IF P(IP(IStart1)) > P(IP(IStart2)) THEN
10910               IPTemp = IP(IStart2)
10920               IP(IStart2) = IP(IStart1)
10930               IP(IStart1) = IPTemp
10940             END IF
10950             IStart = IStart3
10960             NoInPig(IStart) = 1
10970           END IF
10980         ELSE
10990           IStart1 = IStart + 1:REMark Sort 3 with 2 or 3 tests
11000           IStart2 = IStart + 2
11010           IP0 = IP(IStart)
11020           IP1 = IP(IStart1)
11030           IP2 = IP(IStart2)
11040           IF P(IP0) > P(IP1) THEN
11050             IF P(IP2) > P(IP1) THEN
11060               IF P(IP0) >P(IP2) THEN
11070                 IP(IStart1) = IP2
11080                 IP(IStart2) = IP0
11090                 IP(IStart) = IP1
11100               ELSE
11110                 IP(IStart1) = IP0
11120                 IP(IStart) = IP1
11130               END IF
11140             ELSE
11150               IP(IStart2) = IP0
11160               IP(IStart) = IP2
11170             END IF
11180           ELSE
11190             IF P(IP1) > P(IP2) THEN
11200               IF P(IP0) > P(IP2) THEN
11210                 IP(IStart1) = IP0
11220                 IP(IStart) = IP2
11230                 IP(IStart2) = IP1
11240               ELSE
11250                 IP(IStart1) = IP2
11260                 IP(IStart2) = IP1
11270               END IF
11280             END IF
11290           END IF
11300           IStart = IStart2
11310           NoInPig(IStart) = 1
11320         END IF
11330       ELSE
11340         IStart1 = IStart + 1:REMark Sort 2 with 1 swap
11350         IF P(IP(IStart)) > P(IP(IStart1)) THEN
11360           IPTemp = IP(IStart)
11370           IP(IStart) = IP(IStart1)
11380           IP(IStart1) = IPTemp
11390         END IF
11400         IStart = IStart1
11410         NoInPig(IStart) = 1
11420       END IF
11430     END REPeat Loop2
11440     IStart = IStart + NoInPig(IStart)
11450   END REPeat Loop1
11460   RETurn
11470 END DEFine PigeonSort
11480 :
11490 DEFine PROCedure SetupData
11500   LOCal index
11510   RANDOMISE 1
11520   FOR index = 1 TO NMax
11530     DataItems(index) = RND(NMax)
11540     DataIndex(index) = index
11550   END FOR index
11560 END DEFine SetupData
11570 :
11580 DEFine PROCedure validateSort
11590   LOCal index,Value1,Value2
11600   FOR index = 1 TO NMax - 1
11610     Value1 = DataItems(DataIndex(index)):Value2 = DataItems(DataIndex(index + 1))
11620     IF Value2 < Value1 THEN
11630       PRINT 'ERROR IN SORT at index ';index
11640       RETurn
11650     END IF
11660   END FOR index
11670   PRINT 'Sort checked, OK.'\\
11680 END DEFine validateSort
